#include <stdio.h>

int numAlgarismos (int num);
int palindromoDecimal (int num);
int palindromoBinario (int num);
int eleva (int base, int exp);
int tamanhoBinario (int num);

int main()
{
    int num;
    do//pede para digitar um nmero at que ele seja vlido
    {
        printf ("Digite um numero: ");
        scanf ("%d", &num);
        if (num < 0)//condio em que o nmero  invlido
        {
            printf ("Numero invalido!!!\n\n");
        }
    }
    while (num < 0);
    if (palindromoDecimal (num) == 0) //se a funo retornar 0, o nmero no  palndromo na base 10
    {
        printf ("O numero %d NAO eh palindromo na base 10!\n\n", num);
    }
    else //se a funo retornar 1, o nmero  palndromo na base 10
    {
        printf ("O numero %d eh palindromo na base 10!!!\n\n", num);
    }
    if (palindromoBinario (num) == 0) //se a funo retornar 0, o nmero no  palndromo na base 2
    {
        printf ("O numero %d NAO eh palindromo na base 2!\n\n", num);
    }
    else //se a funo retornar 1, o nmero  palndromo na base 2
    {
        printf ("O numero %d eh palindromo na base 2!!!\n\n", num);
    }

    return 0;
}

int numAlgarismos (int num)//funo que calcula quantos algarismos tem o nmero na base 10
{
    int algarismos;
    for (algarismos = 1; num >= 10; algarismos++) //enquanto o nmero for maior que 10, divide-o por 10 e incrementa o algarismos
    {
        num /= 10;
    }
    return algarismos; //retorna o numero de algarismo do nmero na base 10
}

int eleva (int base, int exp) //funo que eleva a base ao expoente
{
    int i, result = 1;
    for (i = 0; i < exp; i++) //enquanto i for menor que o expoente, result vai receber o result * base
    {
        result *= base;
    }
    return result; //retorna o result
}


int palindromoDecimal (int num) //funo que calcula se o nmero  palndromo na base 10
{
    int decimal[200], i, algarismo, palindromo;
    algarismo = numAlgarismos (num);//algarismo  igual ao numero de algarismo do num na base 10
    for (i = 0; i < algarismo; i++) //armazena cada algarismo do nmero numa posio do vetor
    {
        decimal[i] = num / eleva(10, algarismo - i - 1); //a posio do vetor recebe o num / (10^(numeroAlgarismos do numero - i - 1))
        num = num % eleva(10, algarismo - i - 1);//num torna-se o resto da diviso entre num e 10^(numeroAlgarismos do numero - i - 1
    }
    for (i = 0; i < algarismo; i++)
    {
        if (decimal[i] == decimal[algarismo - i - 1]) //se a posio inicial do vetor for igual a ultima, testa a segunda e a penultima, e assim por diante
        {
            palindromo = 1;
        }
        else //se no for igual, o nmero no  palndromo na base 10
        {
            palindromo = 0;
            break;
        }
    }
    return palindromo; //retorna palindromo (0 se no for palndromo ou 1 se for palndromo)
}

int tamanhoBinario (int num) //funo que calcula o tamanho da cadeia binria
{
    int tamanho;
    for (tamanho = 1; num >= eleva (2, tamanho); tamanho++); //enquanto tamanho for maior ou igual a 2^tamanho, incrementa tamanho
    return tamanho;//retorna tamanho
}

int palindromoBinario (int num)
{
    int binario[200], i, palindromo, tamanho;
    tamanho = tamanhoBinario (num); //tamanho  igual ao tamanho da cadeia binria
    for (i = tamanho - 1; i >= 0; i--)//armazena no vetor da ltima posio at a primeira
    { //a posio i do vetor vai ser o resto da diviso do num por 2, e num torna-se num/2 at que i chegue a 0, onde binario[0] = num
        if (i == 0)
        {
            binario[i] = num;
        }
        else
        {
            binario[i] = num % 2;
            num = num / 2;
        }
    }
    for (i = 0; i < tamanho; i++)
    {
        if (binario[i] == binario[tamanho - i - 1]) //se a posio inicial do vetor for igual a ultima, testa a segunda e a penultima, e assim por diante
        {
            palindromo = 1;
        }
        else //se no for igual, o nmero no  palndromo na base 2
        {
            palindromo = 0;
            break;
        }
    }
    return palindromo; //retorna palindromo (0 se no for palndromo ou 1 se for palndromo)
}
