#include <stdio.h>
void calculoPolinomios (int grau_a, int grau_b);
void imprimePolinomio (char polinomio, int vetor[], int grau);
int valorPolinomio (int vetor[], int grau, int valor_x);


int main()
{
    int grau_a, grau_b;
    do //pega os valores do grau_a e grau_b at que os dois sejam vlidos
    {
        printf ("Digite o grau do polinomio A: ");
        scanf ("%d", &grau_a);
        printf ("Digite o grau do polinomio B: ");
        scanf ("%d", &grau_b);
        if (grau_a > 50 || grau_a < 0 || grau_b > 50 || grau_b < 0)//condies em que os graus so invlidos
        {
            printf ("Graus Invalidos!! Digite Novamente\n");
        }
    }
    while (grau_a > 50 || grau_a < 0 || grau_b > 50 || grau_b < 0);
    calculoPolinomios (grau_a, grau_b); //chama a funo que calcula os polinmios
    return 0;
}

void calculoPolinomios (int grau_a, int grau_b) //funo que calcula os polinmios
{
    int grau_c, grau_m, A[51], B[51], C[51], M[101], i, j, valor_x;
    grau_c = ((grau_a > grau_b) ? grau_a : grau_b);//grau_c vai ser grau_a se grau_a > grau_b, ou vai ser grau_b se grau_b >= grau_a
    grau_m = grau_a + grau_b; //grau_m vai ser igual a soma de grau_a com grau_b
    for (i = 0; i <= grau_a; i++)//pega os valores do polinmio A
    {
        printf ("Digite o valor do a%d do polinomio A: ", i);
        scanf ("%d", &A[i]);
    }
    for (i = 0; i <= grau_b; i++)//pega os valores do polinmio B
    {
        printf ("Digite o valor do a%d do polinomio B: ", i);
        scanf ("%d", &B[i]);
    }
    for (i = 0; i <= grau_c; i++)//calcula o polinmio C
        {
            if (i <= ((grau_a > grau_b) ? grau_b : grau_a)) //enquanto i for menor ou igual ao menor dos graus de A e B, C[i] vai ser a soma dos dois polinmios
            {
                C[i] = A[i] + B[i];
            }
            else //quando i for maior que o menor dos graus de A e B, C[i] vai ser igual ao polinmio de maior grau
            {
                if (grau_a > grau_b)
                {
                    C[i] = A[i];
                }
                else
                {
                    C[i] = B[i];
                }
            }
        }
        for (i = 0; i <= grau_m; i++)//zera todas as posies do vetor M
        {
            M[i] = 0;
        }
        for (i = 0; i <= grau_a; i++)//enquanto i for menor ou igual a grau_a, o lao continua
        {
            for (j = 0; j <= grau_b; j++) //enquanto j for menor ou igual a grau_b, o lao continua
            {
                M[i + j] += A[i] * B[j]; //a posio i+j do vetor M  somada a multip da posio i do vetor A com a posio j do vetor B
            }
        }
    imprimePolinomio ('A', A, grau_a); //chama a funo para imprimir o polinmio A
    imprimePolinomio ('B', B, grau_b); //chama a funo para imprimir o polinmio B
    imprimePolinomio ('C', C, grau_c); //chama a funo para imprimir o polinmio C
    imprimePolinomio ('M', M, grau_m); //chama a funo para imprimir o polinmio M
    printf ("\n\nDigite o valor de x: ");
    scanf ("%d", &valor_x);//pega o valor de x
    printf ("\nA(%d) = %d", valor_x, valorPolinomio (A, grau_a, valor_x));//chama a funo que calcula o resultado do polinmio A
    printf ("\nB(%d) = %d", valor_x, valorPolinomio (B, grau_b, valor_x));//chama a funo que calcula o resultado do polinmio B
    printf ("\nC(%d) = %d", valor_x, valorPolinomio (C, grau_c, valor_x));//chama a funo que calcula o resultado do polinmio C
    printf ("\nM(%d) = %d", valor_x, valorPolinomio (M, grau_m, valor_x));//chama a funo que calcula o resultado do polinmio M
}

void imprimePolinomio (char polinomio, int vetor[], int grau) //funo que imprime o polinmio
{
    int i;
    printf ("\n");
    printf ("%c : ", polinomio);//imprime qual polinmio que vai ter os valores impressos
    for (i = 0; i <= grau; i++) //enquanto i for menor ou igual ao grau do polinmio, imprime o valor que est na posio i do vetor
    {
        printf ("(%d)x^%d ", vetor[i], i);
        if (i != grau)
        {
            printf("+ ");
        }
    }
}

int valorPolinomio (int vetor[], int grau, int valor_x)//funo que calcula o resultado do polinmio
{
    int result = 0, i;
    for (i = 0; i <= grau; i++) //enquanto i for menor ou igual ao grau, o lao continua
    {
       result += vetor[i] * pow(valor_x, i); //resultado vai ser igual a soma do resultado com a multiplicao da posio i do vetor com x elevado a i
    }
    return result;//retorna o resultado
}




