#include <stdio.h>

int testeParidade (int matriz[][200], int N);
int modificaParidade (int matriz[][200], int N);

int main()
{
    int N, i, j, matriz[200][200];
    do //pede para digitar o tamanho da matriz at que ele seja vlido
    {
        printf ("Digite o tamanho N da matriz: ");
        scanf ("%d", &N); //pega o tamanho da matriz
        if (N <= 0 || N > 200) //condies em que o tamanho da matriz  invlido
        {
            printf ("\nTamanho N invalido!!\n\n");
        }
    }
    while (N <= 0 || N > 200);
    for (i = 0; i < N; i++)//pega os valores da matriz
    {
        for (j = 0; j < N; j++)
        {
            do//pede para digitar o valor da linha i e coluna j da matriz at que ele seja vlido (0 ou 1)
            {
                printf ("Digite o valor da posicao [%d][%d] da matriz: ", i, j);
                scanf ("%d", &matriz[i][j]);
                if (matriz[i][j] != 0 && matriz[i][j] != 1)
                {
                    printf ("\nValor invalido!!!\n\n");
                }
            }
            while (matriz[i][j] != 0 && matriz[i][j] != 1);
        }
    }
    if (testeParidade (matriz, N) == 1) //se essa funo retornar 1, a matriz possui a propriedade de paridade
    {
        printf ("\nA matriz possui a propriedade de paridade!!\n");
    }
    else //se essa funo retornar 0,  porque a matriz no possui a propriedade de paridade
    {
        printf ("\nA matriz NAO possui a propriedade de paridade!!\n");
        if (modificaParidade (matriz, N) == 0) //se essa funo retornar 0  porque no eh possvel tornar a matriz com a propriedade de paridade modificando s um elemento
        {
            printf ("\nNAO eh possivel estabelecer essa propriedade modificando apenas um valor da \nmatriz!!\n");
        }
        else //se essa funo retornar 1  porque  possvel tornar a matriz com a propriedade de paridade modificando s um elemento
        {
            printf ("\nEh possivel estabelecer essa propriedade modificando apenas um valor da matriz!!\n");
        }
    }

    return 0;
}

int testeParidade (int matriz[][200], int N) //funo que testa se a matriz possui a propriedade de paridade
{
    int i, j, soma;

    for (i = 0; i < N; i++)
    {
        soma = 0;
        for (j = 0; j < N; j++)
        {
            soma += matriz[i][j]; //soma os elementos da linha da matriz
        }
        if (soma % 2 != 0) //se a soma dos elementos da linha no for divisvel por 2, a funo retorna 0 (falso)
        {
            return 0;
        }
    }
    for (j = 0; j < N; j++)
    {
        soma = 0;
        for (i = 0; i < N; i++)
        {
            soma += matriz[i][j]; //soma os elementos da coluna da matriz
        }
        if (soma % 2 != 0) //se a soma dos elementos da coluna no for divisvel por 2, a funo retorna 0 (falso)
        {
            return 0;
        }
    }
    return 1; //retorna 1 (verdadeiro), se a soma das linhas e das colunas for divisvel por 2
}

int modificaParidade (int matriz[][200], int N) //funo que testa se a matriz pode possuir a propriedade de paridade modificando apenas um elemento da matriz
{
    int i, j, soma, modificaLinha = 0, modificaColuna = 0;
    for (i = 0; i < N; i++)
    {
        soma = 0;//zera a soma dos elementos da linha
        for (j = 0; j < N; j++)
        {
            soma += matriz[i][j]; //soma os elementos da linha
        }
        if (soma % 2 != 0) //se a soma dos elementos da linha no for divisvel por 2, a linha i ter que ser modificada
        {
            modificaLinha++;//incrementa o modificaLinha, que definir quantas linhas tero que ser modificadas
        }
    }
    if (modificaLinha > 1) //se mais de uma linha tiver que ser modificada, mais de um elemento ter que ser modificado da matriz
    {
        return 0;//retorna 0 (falso)
    }
    else
    {
        for (j = 0; j < N; j++)
        {
            soma = 0; //zera a soma dos elementos da coluna
            for (i = 0; i < N; i++)
            {
                soma += matriz[i][j]; //soma os elementos da coluna
            }
            if (soma % 2 != 0) //se a soma dos elementos da coluna no for divisvel por 2, a coluna j ter que ser modificada
            {
                modificaColuna++;//incrementa o modificaColuna, que definir quantas colunas tero que ser modificadas
            }
        }
        if (modificaColuna > 1) //se mais de uma coluna tiver que ser modificada, mais de um elemento ter que ser modificado da matriz
        {
            return 0;//retorna falso
        }
        else if (modificaColuna != modificaLinha) //se tiver que ser modificado uma linha e nenhuma coluna ou vice-versa
        {
            return 0;//retorna falso
        }
        else //se uma linha e uma coluna tiver que ser modificada, a interseo da linha com a coluna ser trocada
        {
            return 1;//retorna verdadeiro
        }
    }
}


























